﻿#pragma once
#include "..\..\DuiLib\UIlib.h"
#include "GdiPlusWrapper.h"
#include "SkinDialog.h"
#include "NMDropTarget.h"
#include "NTalk.h"
#include "RichEditCtrlEx.h"
#include "ChatModel.h"
#include "ChatSendMsgThread.h"
#include "InfoItemWnd.h"
#include "ChatUserList.h"
#include "ChatSplitterWnd.h"
#include "ChatStatusWnd.h"
#include "NMImgTabButton.h"
#include <queue>
#include "StickerItem.h"
//#include "RecentUsedStickers.h"
//#include "ChatMainBubble.h"
//#include "ChatMainPlain.h"
#include <ftlbase.h>
#include <ftlNet.h>
#include <ftlSharePtr.h>
#include <ftlThreadPool.h>
#include "ChatMainView.h"
#include "LayeredDlg.h"
#include "ChatLeftList.hpp"

#define CHATROOM_SINGLETYPE					1
#define CHATROOM_MULTITYPE					10

#define	MAX_TRANSLATE_FILES_COUNT			10
//30M
#define MAX_TRANSLATE_FILE_SIZE				(30 * 1024 * 1024)
#define SLIDEBAR_WIDTH                      30
#define SLIDEBAR_RIGHT                      11
#define SPLIT_STRING						(_T(", "))

#define MSG_CLICK_MAIN_VIEW					(WM_USER + 9900)
#define MSG_CLOSE_INVITE_WINDOWN			(WM_USER + 9901)

typedef struct _SEND_CHAT_MESSAGE 
{
	CString		strMsg;
	CHARFORMAT2	cfFontStyle;
	UINT		nTid; 
	UINT		nMsgSeq;
	BYTE		msgType;
} SEND_CHAT_MESSAGE, *P_SEND_CHAT_MESSAGE;

typedef struct _SEND_FILE_MESSAGE
{
	AttachFileInfo			attachFile;
	std::vector<wstring>	m_vecReceiverIds;
	UINT					nTid;
	UINT					nMsgSeq;
	BYTE					msgType;
}SEND_FILE_MESSAGE, *P_SEND_FILE_MESSAGE;

typedef std::map<int, int>	GROUP_MEMU_LIST;

class CChatModel;
class CStickerDlg;
class CNFontDialog;
class CNFontWnd;
class CStickersWindow;
class CChatLeftWnd;
class CChatToolBar;
class MainFrame;
class CChatSearchWnd;

class CFileDialogEx : public CFileDialog
{
	DECLARE_DYNAMIC(CFileDialogEx)

public:
	CFileDialogEx(CPoint pt,CString str,CWnd* parent);
	virtual ~CFileDialogEx();
public:
	//BOOL OnInitDialog();
	
	void OnInitDone();
public:
	CPoint m_point;

protected:
	DECLARE_MESSAGE_MAP()		
};
class CChatDlg : public WindowImplBase, 
	private IGTWASActorEvent, 
	private INTalkClientEvents, 
	private IGTMessengerActorEvent,
	private CAMSWnd,
	private CAMSWnd::PlacementHook,
	public FTL::IFThreadPoolCallBack<FTL::FTransferJobInfoPtr>
{
    DUI_DECLARE_MESSAGE_MAP()
    DUI_DECLARE_CUSTOM_MSG_MAP()
public:
	CChatDlg();   // 표준 생성자입니다.
	virtual ~CChatDlg();
	BOOL    UserGivenRect(LPRECT lpRect);
	//void    RemoveUnnecessaryMessage();
	bool	SyncFileTranslateInfo( TranslateFileInfoPtr& pUploadFileInfo );
	//bool	IsHiddenByEscEtc(){return m_bHideOnEscEtc;}
	//void	SetHiddenByEscEtc(bool flag){m_bHideOnEscEtc = flag;} //If you wonder why the interface is created, please ask jializhen

	//void	MoveSplitter();
	void    AlertOfflineUser( );
	void    InitChannel(int channel=0);
	void	InitControls();
	void	JudgeReadOnly();
	void	StopChatFlash();
	BOOL	SaveRoomData(NE_MYROOM_DATA &roomData);

	void	__ResourceLoad(BOOL bInit = FALSE);
	BOOL	AddChatUserList(vector<CChatUser*> vecUser);
	void	SetRequestGetTalkNameTrid(trid_t tid);

    //refactor SetReadOnly and SetUIReadOnly to SetReadOnly according svn 10337
    //  bNetwork indicate the consider network situation(such as NtalkClient_OnRoomEnd, TIMER_CHAT_RECOVERY_NETWORK)
	void	SetReadOnly(BOOL bReadOnly, BOOL bNetwork);
	void	SetAllUserOffline();
	int		CreateChatSession();
	CChatMainView* GetChatMainViewPtr();
	void	SetRestoreLeftWindow(bool bRestore);
	void	DisplayNetworkErrorMessage();
	void	DisplayServerSessionEndMessage();
	void	DisplaySeverSessionRecoveryCompleted();
	void	CheckSessionStatus();
	
	void	OnChangeDisplayStyle();
	BOOL	GetSessionRetryAvailable()	{ return m_bTryRecoverySession; }
	void	SetSessionRetryAvailable( BOOL bAvailable ) { m_bTryRecoverySession = bAvailable; };
	void	SetModalStatus(bool bModal);
	int		GetAllUserCount();
	void	CancelTransferFile();

	P_SEND_CHAT_MESSAGE GetChatMsgFromQueue(BOOL* pbCheckStop);
	P_SEND_FILE_MESSAGE GetFileMsgFromQueue();
	//void	RemoveChatMsgFromQueue();
	void	AddUser(std::vector<NE_MEMBER_DATA>& vAddUsers);	// 대상자 추가 다이얼로그에서 호출한다.
	void	SetChatInfo(int nSeqNumber, const vector<CChatUser*>& userList, EChatMakeType enumMakeType);
	void	ResendChatMsg(UINT nMsgSeq, UINT nTid, CString strChatMsg, CHARFORMAT2 cf, BYTE msgType);
	CString GetChatUsrNames()  {return m_strChatUserNames;};			
	virtual bool OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID);
	bool GetNeedRestoreChatRoom(){

		return m_bNeedRestoreRoomID;
	}

	void SetNeedRestoreChatRoom(bool flag){

		m_bNeedRestoreRoomID = flag;
	}
// 	AllStickerVec* GetStickerVector()		{ 
// 		return &m_vecAllSticker; 
// 	}


// 	RecentStickerVec* GetRecentStickerVector()		{ 
// 		return &m_vecRecentSticker; 
// 	}

	UIElement* MakeDownloadFileJob(TranslateFileInfoPtr& pDownloadFileInfo, bool bRestore = true);
	UIElement* MakeUploadFileJob(TranslateFileInfoPtr& pUploadFileInfo, bool bRestore = true);
	INTalkClient*	m_pNtalk;	

	CChatModel* GetChatModel(); 
	void PopupMenuView(CPoint pt, int nMain,int nSub);
	void MakeFavoriteMenu(CMenu* menu, int nSub);

	virtual void OnFinalMessage(HWND hWnd);
	CChatLeftList* GetLeftList(); 

	CRichEditUI * GetChatEdit();

// 대화 상자 데이터입니다.
	enum { IDD = IDD_CHAT_DIALOG };
	

protected:
	GROUP_MEMU_LIST	m_GroupList;
	vector<Node*>	m_vecSelectItems;
	int				m_nCursor;
	CRect			m_rtSplitter;
	BOOL			m_bSplitterClicked;
	bool			m_bRestoreLeftWindow;
	//CWnd			*m_pLeftWnd;
	CWnd			*wnd;
//	CChatToolBar	*m_pChatToolBar;
//	HICON			m_hIcon;	
// 	CNMImgButton	m_btnFont;					// 폰트설정 버튼	
// 	CNMImgButton	m_btnSticker;				// 스티커
// 	CNMImgButton	m_btnFile;
	bool			m_bScrollock;
	BOOL			m_bOnceTrayPopup;			// 채팅 내용 트레이 팝업을 한번만 보여준다
	CHARFORMAT2		m_cf;	
	//COLORREF		m_editColor;
	BOOL			m_bEnableDragAndDrop;		// 드래그앤 드랍 가능상태
	BOOL			m_bBeforeStatusOfTyping;	// 타이핑 상태정보 체크

	CChatSendMsgThread	*m_pSendMsgThread;

	//std::queue<P_SEND_CHAT_MESSAGE> m_qChatMsg;
    FTL::CFProducerResumerQueue<P_SEND_CHAT_MESSAGE> m_qChatMsg;

	//CCriticalSection m_csSendMsg;

	int				m_nInviteRetryCount;
	std::list<HANDLE>	m_hInviteThreadList;
	BOOL			m_bTryRecoverySession;
	CNFontWnd*      m_pFontDlg;
    CStickersWindow* m_pStickerDlg;
	CNMDropTarget	m_DT;
	BOOL			m_bPrepared;
	CChatUserList	m_listChatUser;				// 대화창 상단의 사용자 리스트
	CImageList		m_ilStatus;					// 사용자의 상태 이미지
	CImageList		m_ilIPTStatus;

// 	CInfoItemWnd	m_btnChatSendMemo;
// 	CInfoItemWnd	m_btnChatInvite;


// 	CChatSplitterWnd	m_wndChatSplitter;

	CChatStatusWnd	m_wndChatStatus;

	CString			m_strTitle;					// 대화창 제목
	CString			m_strChatUserNames;			// 대화창 제목의 상대 이름 리스트(이름만 있음)
	CRect			m_rtTitle;

	CRect           m_rtSlideBar;
	int             m_nSlidePos;
	BOOL            m_bSlideCapture;

	REAL			m_nChatUserFontHeight;
	REAL			m_nChatUserCountFontHeight;
	REAL			m_nFixedTitleFontHeight;

	Color			m_crChatUserTxt;
	Color			m_crChatUserCountTxt;
	Color			m_crFixedTitleTxt;

	vector<LPCTSTR> m_vecSendMemoExUser;

	int				m_nPingPongCount;
	CRichEditCtrlEx	m_editSend;	
	CTime			m_creationTime;
	std::list<trid_t>	m_tridListGetEmployeeInfo;

	trid_t			m_trid;

	CCriticalSection	m_csInviteUserThd;
	CChatModel		m_chatModel;

	bool m_bFlashFlag;
	int  m_nFileTransIndex;
	bool m_bHideOnEscEtc;
	int m_TileHeight;
	CChatItem* m_pSearchChatItem;
	CString    m_strFileOrStickerMsg;
	BOOL m_bForceLeave;
    BOOL m_bReadOnlyByNetwork;  //set this by CNeMessengerDlg::DisableWindows -> SetReadOnlyAll -> SetReadOnly
    BOOL m_bRoomEnd;            //set this in NtalkClient_OnRoomEnd, but how this happen?
	int m_channel;
	CChatMainView*	m_pChatMainView;
	bool			m_bTopMost;
	bool			m_bRemoveChatDlgWhenChatClose;	// 퇴장해야 할 대화방인 경우 채팅세션이 생성될 때 퇴장처리한다.
	
	// Sticker
//	std::vector<CStickerItem*> m_vecAllSticker;		// 모든 스티커 데이터
//	std::vector<int>   m_vecRecentSticker;
	//CLayeredDlg  *m_pWorkStatusLayerDlg;

	trid_t			m_getMessageTrid;
	bool            m_bshowtip;

	CString			m_strOpenDirInitPath;
	FTL::CFCriticalSection	m_lockSendFileJobInfos;
	FTL::CFInternetTransfer*	m_pInternetTransfer;

	// left window
	CChatSearchWnd  *m_pChatSearchWnd;
	//CRect m_rcClient;
	ChatListItemInfo m_friendListInfo;
	//MainFrame *m_pMainFrame;
	CString m_strSearchWord;
    BUDDY_SENDACTIONType m_OnGoingAction;
	
    CRichEditUI* m_pEditChat;
	CButtonUI* m_pBtnFile;
    CButtonUI* m_pBtnSticker;
    CButtonUI* m_pBtnText;
    CButtonUI* m_pBtnSearch;
    CButtonUI* m_pBtnAddUser;
    CButtonUI* m_pBtnMin;
    CButtonUI* m_pBtnMax;
    CButtonUI* m_pBtnClose;
    CButtonUI* m_pBtnRestore;

    CButtonUI* m_pBtnPin;
    CSliderUI* m_pSliderOpacity;
    CEditUI*   m_pSearchEdit;
    CButtonUI* m_pSearchLabel;
    CLabelUI*  m_pChatNumLabel;
    DWORD      m_dwLastTypingTicket;
    DWORD      m_dwLastSendTypingTicket;
	bool   m_bNeedRestoreRoomID;

    LRESULT OnMsgChatDlgSendFile(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    //LRESULT OnMsgChatEditKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    //LRESULT OnMsgChatEditFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgSysKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgActivate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgKeyUp(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgChatFontDlgClosed(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgPopupTrayDlg(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgClickTray(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgChatMsgPopupTrayDlg(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgChatStickerSelected(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgChatStickerDlgClosed(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgNotifyStatusPopup(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgAddUserChat(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgTimer(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgClickMainView(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgCloseChatSearch(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnMsgCloseInviteWindow(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnSizing(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	virtual LRESULT OnKeyDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);
	virtual LRESULT OnNcLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	virtual LRESULT OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    virtual LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    virtual LRESULT OnLButtonDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);
    virtual LRESULT OnChar(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	BOOL SendFileNotify(TranslateFileInfoPtr& pTranslateFileInfo, CFJobBase<FTransferJobInfoPtr>* pJob);

	//IFThreadPoolCallBack
	virtual void OnJobBegin(LONG nJobIndex, CFJobBase<FTransferJobInfoPtr>* pJob);
	virtual void OnJobEnd(LONG nJobIndex, FTL::CFJobBase<FTransferJobInfoPtr>* pJob);
	virtual void OnJobCancel(LONG nJobIndex, FTL::CFJobBase<FTransferJobInfoPtr>* pJob);
	virtual void OnJobProgress(LONG nJobIndex, FTL::CFJobBase<FTransferJobInfoPtr>* pJob, 
		LONGLONG nCurPos, LONGLONG nTotalSize);
	virtual void OnJobError(LONG nJobIndex, CFJobBase<FTL::FTransferJobInfoPtr>* pJob, 
		DWORD dwError, LPCTSTR pszDescription); 

public:
	
	virtual CControlUI* CreateControl(LPCTSTR pstrClass);
	void			LoadSkin();
	LPCTSTR			GetWindowClassName() const;
	CDuiString		GetSkinFile();
	CDuiString		GetSkinFolder();
	void			RecalcTitleRect(); 
	CRect           GetSlideBtnRect(const CRect& rtSlideBar, int nSlidePos);
	int				ExpandWindow(bool bExpand,int nCmdShow = SW_SHOWNOACTIVATE);
	int				ShowChatList(bool bShow);
	void			HideShowLeftList();
	void			AddChatUserToListCtrl(CChatUser* pChatUser,bool bSync = true);
	void			AddChatUserToListCtrl(CString strID, CString strName, CString strNickName, GTUserStatusType onlineStatus, CString strExtensionTel = _T(""), CString strCellphone = _T(""), CString strJobPos = _T(""), CString strJobDuty = _T(""), CString strDeptName = _T(""), bool bSync = true);
	void			SetChatSysMsg(UINT nID, LPCTSTR strName,  LPCTSTR userid);
	void			SetUserJoinMsg(UINT nID, LPCTSTR strName, BOOL bJoin);
	
	void			DoChatSendMemo();
	void			DoChatSendFiles();
	void			DoChatInvite();
	void            SetOngoingAction(BUDDY_SENDACTIONType Action){m_OnGoingAction = Action;};
	BUDDY_SENDACTIONType            GetOngoingAction(){return  m_OnGoingAction;};
	bool			NegotiateChatSession();
	void			CloseChatDialog(bool willRestoreRoomID = false, bool bCloseChat = true);
	void			CheckCloseChatDialog();
	void			CloseChatSession();

	void			EnableDragAndDrop(BOOL bEnable);
	BOOL			IsEnableDragAndDrop();

	ESession		GetSessionStatus();
	EInitRoom		GetInitRoomStatus();
	EInviteList		GetInviteListStatus();

	BOOL			InitChatRoom();
	BOOL			RequestTyping(BOOL bFirstStatus);
	void			ChangeNickNameChatUserList(LPCTSTR strUserID, LPCTSTR strNickName);
	void			DisplayPopupAndFlashEffect( CHAT_MSG* pItem, CString strMyID );
	void			DisplayPopupAndFlashEffect(TranslateFileInfoPtr pFileInfo, CString strMyID );
	void			DisplayChatErrorMessage( CString showChatErrorMessage, bool bRestore = true, bool bFlashWindow = true);
	void			DisplayErrorSessionMessage(CString showChatErrorMessage);
	void			RecoveryServerSession();
	BOOL			InviteChatUser();
	void			RemoveAllUser();
	CTime&			GetCreationTime() { return m_creationTime; }
	//CTime&          GetLastMsgTime(){return m_lastMsgTime;}
	void            SetCreationTime(CTime& lastmsgtime) {m_creationTime = lastmsgtime;}           
	int				GetTitleHeight() { return m_TileHeight; }
	BOOL 			CheckSendFileInfos(const std::vector<CString>& attachFileVector, std::vector<AttachFileInfo>& attachFileFileVector);
	BOOL 			SetSendFile(const std::vector<CString>& attachFileVector);
	bool			CancelTransferJob(LONG nJobIndex);
	bool			StartDownloadFile(TranslateFileInfoPtr& pDownloadFileInfo);

	BOOL			IsInChat( CString strSearchText );
	CChatItem*		GetChatSearchResult() { return m_pSearchChatItem;}
	void			ClearChatSearchResult() { m_pSearchChatItem = NULL;}
	void			AdjustChatWindowToSearchResult();
	void			SetWindowTop();
	void			SetForceLeave(BOOL bValue) { m_bForceLeave = bValue; }
	BOOL			GetForceLeave() { return m_bForceLeave; }
	void			SetForegroundWindowForce(HWND hWnd);
	void			ReSizeCtrl(BOOL bReverse = FALSE);

    //TODO: what's the effect of this code?
	BOOL			EnableWindow(BOOL enable){return ::EnableWindow(m_hWnd,enable);}
	bool			IsFocused();
	BOOL			IsIconic(){return ::IsIconic(m_hWnd);}
	BOOL			IsZoomed(){return ::IsZoomed(m_hWnd);}
	HWND			GetSafeHwnd(){return m_hWnd;}
	CWnd*			GetCWnd(){return wnd;}
	trid_t			GetChatTrid();
	int				FindUserMap(LPCTSTR strUserID);
	BOOL			IsGroupRoom() { return m_chatModel.IsGroupRoom(); }	
	int				GetRoomID() { return m_chatModel.GetRoomID(); }
	BOOL			IsEqualChatDlg(const std::vector<CChatUser *>& userList, LPCTSTR strAddress, int nPort, int nRoomID);
	void			SetChatRoomMakeType(EChatMakeType eMakeType) { m_chatModel.SetChatRoomMakeType(eMakeType); }
	void			SetInviteUserName(LPCTSTR strInviteUser) {m_chatModel.SetInviteUserName(strInviteUser); }
	void			SetServerInfo(LPCTSTR strSrvAddress, int nSrvPort, int nRoomID, LPCTSTR strRoomType);
	void			SetSessionReason(ESessionReason reason) { m_chatModel.SetSessionReason(reason); }
	void			ResetCreateSessionCheckTimes() { m_chatModel.ResetCreateSessionCheckTimes(); }
	CHARFORMAT2		GetDefaultChatFont() { return m_chatModel.GetDefaultChatFont(); }

	/*
	[CN comment]
	侶좃몸쌈왯럿쀼돨떼角뇜菱성裂棍돨젬溝훙츰냔俚륜눔。혐깎角： 
	품諒럿쀼轟埼돨츰냔string，츰냔탤죗糠埼踞샙; 빈諒럿쀼뵨chat left list鞫刻糠埼寧鈴돨츰냔string，탤埼뵨젬溝휑츰냔/뎠품榴檄唐밑。	
	*/
	CString			GetAllUserName() { return m_chatModel.GetAllUserName();}
	CString			GetAllUserNameFromList();
	CString			GetAllUserIDFromList();

	CChatItem*		GetLastMsgItem(BOOL bGetSearchlastMsg = TRUE);
	CString			GetLastMsg(BOOL bGetSearchlastMsg = TRUE);
	CString			GetLastFileOrStickerMsg() {return m_strFileOrStickerMsg;};
	void            SetLastFileOrStickerMsg(CChatItem* item);
	int				GetChatUserMapCount() { return m_chatModel.GetChatUserMapCount(); }
	CString			GetChatUserID(int idx) { return m_chatModel.GetChatUserID(idx); }
	CString			GetMyUserID() { return m_chatModel.GetMyID(); }

	UIElement*		AddChatItem(CString strUserID, CString strName, CString strTalkName, CTime time, 
								CString strChatMsg, CHARFORMAT2 cf, UINT nTid = 0, UINT nMsgSeq = 0, 
								BYTE msgType = DEF_CHAT_MSG_TYPE_CHAT,
								TranslateFileInfoPtr typeData = CFSharePtr<TranslateFileInfo>(NULL), bool bRestore = true);
	void			DrawChatItem(CString strUserID, CString strName, CString strTalkName, CTime time, 
									CString strChatMsg, CHARFORMAT2 cf, UINT nTid = 0, UINT nMsgSeq = 0, 
									BYTE msgType = DEF_CHAT_MSG_TYPE_CHAT);
	BOOL			IsScrollLocked();
	void			SetScrollLock(bool bLock);

	bool			UpdateBuddyStatus(/*IGTMessengerActor *pActor,*/ LPCWSTR strBuddyID, int nTypeBits);
	bool			UpdateNotBuddyStatus(/*IGTMessengerActor *pActor,*/ LPCWSTR strBuddyID, int nUserStatus, LPCWSTR strNick, int nIPTStatus, int nFlag);

	void			SetRemoveChatDlgWhenChatClose(bool bClose)	{m_bRemoveChatDlgWhenChatClose = bClose;}
	void			SetGroupRoom(BOOL bGroupRoom) { m_chatModel.SetGroupRoom(bGroupRoom); }

	BOOL			AddRecentContact();
	//BOOL            AddRecentUsedStickers(int);
	void	RemoveItem(LPCTSTR strUserID);
	void OnBnClickedButtonFont();
	void OnBnClickedButtonSticker();
	void OnBnClickedButtonFile();
	BOOL IsFocuseOnSearchEdit();
	void OnSearchUser();
	void CloseChatSearchWnd(BOOL bClearSearchEdit = FALSE, BOOL bSetFocusToRichEdit = FALSE);
	CChatLeftList* GetFriendsCtrl();
	int     GetChatContactCntExceptMe();

	virtual LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	void	RefreshTitle(bool bSync = true);	

protected:
	bool RecoveryNetworkError();
	bool IsCloseRequest( MSG* pMsg );

	virtual void PostNcDestroy();
	void OnPrepare(TNotifyUI& msg);	
    void OnNotifyAlphaChange(TNotifyUI& msg);

    void OnNotifySetCursor(TNotifyUI& msg);	
    void OnNotifyDragMoving(TNotifyUI& msg);
    void OnNotifyReturn(TNotifyUI& msg);
    void OnNotifySetFocus(TNotifyUI& msg);
    void OnNotifyKillFocus(TNotifyUI& msg);
    void OnNotifyClick(TNotifyUI& msg);
    void OnNotifyItemClick(TNotifyUI& msg);
    //void OnNotifyClickMenuTopMost(TNotifyUI& msg);

	virtual LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	

	void AddMyInfoToChatUserList();

	bool CreateChatMainView();
    void InitDuiControls();
	void InitRichEditCtrl();
    void _DisplayChatNumInfo(const CString& strTitle);
	void AssignChatEditCharformat();
	void SetSendEditParaFormat();
	void RegisterWindowandCreateButtons();

	void RegisterObserver();
	void RequestNewRoom();

	void AssignMenuandIcon();

	void AssignDropTarget();

	void AssignDefaultFont();

	BOOL IsNeedMinimize(LPCTSTR strUserID);

	void CheckSendMsgAck();
	void CheckSendFileAck();
	void ReceiveChatMsg();
	void ReceiveChatFile(TranslateFileInfoPtr pTranslateFileInfo);

	LRESULT OnSysCommand(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnPopupTrayDlg(WPARAM wParam, LPARAM lParam);
	LRESULT OnChatMsgPopupTrayDlg(WPARAM wParam, LPARAM lParam);
	LRESULT OnClickTray(WPARAM wParam, LPARAM lParam);


	LRESULT OnStickerSelected(WPARAM wParam, LPARAM lParam);
	LRESULT OnStickerDlgClosed(WPARAM wParam, LPARAM lParam);
	LRESULT OnFontDlgClosed(WPARAM wParam, LPARAM lParam);
	LRESULT OnListNotifyHover(WPARAM wParam, LPARAM lParam);
	LRESULT OnAddUserToChat(WPARAM wParam, LPARAM lParam);
	void OnTimer(UINT_PTR nIDEvent,BOOL& bHandled);
//	void CloseStickerDlg();
	void  OnMenuTopMost();
	void  OnMenuSendMemo();
	void  OnMenuSendFiles();
	void  OnMenuInvite();

	void ShowWorkStatusPopup( int nIndex );
	void HideWorkStatusPopup();

private:
	LRESULT _OnCommandMenuKickUser(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
	LRESULT _OnCommandMenuChatHistory(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
	LRESULT _OnCommandMenuInvite(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
	LRESULT _OnCommandMenuSendFiles(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
	LRESULT _OnCommandMenuSendMemo(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);
	LRESULT _OnCommandMenuTopMost(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled);

    BOOL	_IsReadOnlyStatus();
	void	_SetReadOnly(BOOL bReadOnly, BOOL bCanInviteUser);
    void    _UpdateChatItemMsgResultInfo(CChatItem *pChatItem, bool bFail, UINT tid, 
        int time, const CString& strUserName);

    BOOL	IsAnyFTProcessRunning();
	BOOL	GetChatMsg(CString &strChatMsg);
	BOOL	SendChatMsg(BYTE msgType, CString strMsg = _T(""));

	void	SetChatStatusMessage(UINT nID, LPCTSTR strName);
	void	OnMenuKickUser();
	void	OnMenuUserProfile();
	void	OnMenuChatHistory();
	void	OnMenuChatHistoryOnTopMenu();
	
	SIZE    EstimateSize(SIZE szAvailable,CString m_sText,DWORD m_dwTextColor,DWORD m_uTextStyle);



	void	ResizeUserListCtrlHeight( int nUserCount );

	void	SetUserActionStatusText(NTalkTyping eState, LPCTSTR strName, LPCTSTR strUserID, int nOSType);
	void SetInputStatusText(CString strStatus);

	BOOL	IsDuplicateUser(LPCTSTR strUserID);

	void	ProcRegiFavoriteToPOI();
	void	ProcRegiFavoriteToPOI(CString strUser);
	void	ProcRegiFavoriteToPOI(vector<wstring> vecUsers);

	void	ProcUregFavoriteFromPOI();
	void	ProcUregFavoriteFromPOI(wstring strUser);
	void	ProcUregFavoriteFromPOI(vector<wstring> &vecUsers);

	void	ProcChatUserNickName();
	void	RequestChatUserInfo();	//비즈니스 로직 서버로  대화상대의 정보를 요청할 함수
	
	void	ChangeNickNameChatUserList(const std::vector<NT_TALKNAME_DATA> listTalknameData);
	void	UpdateStatus( GTUserStatusType stStatus, int nItem, CString strUserID );
	void	UpdateIPTStatus(NTIPTStatusType eIPTStatus, int nItem, CString strUserID);
	
	BOOL	RequestRegisterChatUsers(vector<PINVITE_USER> vecInvites);
	BOOL	SendNotification();
	BOOL	IsNeedInviteOthers(vector<PINVITE_USER> vecInvites);

	void	RemoveUser(LPCTSTR strUserID);

	static unsigned int __stdcall InviteChatUserThd(LPVOID pArg);
	BOOL	InviteUsers(vector<wstring> vecUser);	
//	void	SetModalStatus(bool bModal);

	void	FlashEffect(bool bSound = true);
	void	InitChatUserListCtrl();
	int		GetImageIndexFromStatus(GTUserStatusType eMyStatus);
	void	OnMenuIPT(WPARAM wParam);
	void	CallToIPT(NE_MEMBER_DATA userData, CString strTel);
	void	AddChatToMainView( CHAT_MSG* pItem );
	CString ConvertUserNameToMyLanguage(CString strUserID);
	void	OnBnClickedButtonScrollLock();
//	void	DeleteStickerData();
	void	SetMyInfo();
    virtual LRESULT OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	virtual void CALLBACK NtalkClient_OnCreateChatSession(INTalkClient* pNTClient, 
														   NTalkCreateChatType chatType,
														   NTalkCreateSesionErrorCode eErrorCode);
	
	virtual void CALLBACK NtalkClient_OnReceiveChatMsg(INTalkClient* pNTClient,
														 int roomid, 
														 LPCTSTR userid,
														 LPCTSTR nickname,
														 int os_type, 
														 int time,
														 LPCTSTR pszMsg,
														 UINT msg_seq, 
														 CHARFORMAT2* pFont, 
														 UINT nTid,
														 BYTE msgType);

	virtual void CALLBACK NtalkClient_OnReceiveFile(INTalkClient* pNTClient, 
		int roomid, 
		LPCTSTR userid, 
		LPCTSTR nickname, 
		int os_type,
		int time, 
		LPCTSTR pszFileName, 
		int nFileSize, 
		LPCTSTR pszURL, 
		UINT msg_seq, 
		UINT tid, 
		BYTE msgType);

	virtual void CALLBACK NtalkClient_OnReceiveTypingMsg(INTalkClient* pNTClient,
														 int roomid,
														 LPCTSTR userid,
														 LPCTSTR nickname,
														 int nOSType,
														 NTalkTyping state);

	virtual void CALLBACK NtalkClient_OnChatLeaveJoiner(INTalkClient* pNTClient, int roomid, 
														LPCTSTR userid, LPCTSTR nickname, 
														int os_type, int time, UINT membercount);

	virtual void CALLBACK NtalkClient_OnPushForceLeave(INTalkClient* pNTClient, int roomid, 
														LPCTSTR userid);

	virtual void CALLBACK NtalkClient_OnPushSessionClose(INTalkClient* pNTClient, int roomid);
	
	virtual void CALLBACK NtalkClient_OnChatJoin(INTalkClient* pNTClient,
												 NTalkChatJoinErrorCode eErrorCode,
												 int roomid,
												 std::vector<PINVITE_USER>& vecUserList, 
												 int roomtype, 
												 UINT nJoinNum, 
												 UINT nLastMsgNum);

	virtual void CALLBACK NtalkClient_OnForceChatReJoin(INTalkClient* pNTClient, 
															NTalkChatJoinErrorCode eErrorCode, 
															int roomid, 
															std::vector<PINVITE_USER>& vecUserList); 
	
	virtual void CALLBACK NtalkClient_OnNewJoiner(INTalkClient* pNTClient, 
												  int roomid,
												  LPCTSTR userid,
												  LPCTSTR nickname,
												  int time,
												  UINT membercount, 
												  int jointype,
												  int ostype);

	virtual void CALLBACK NtalkClient_OnForceReJoiner(INTalkClient* pNTClient, 
													  int roomid,
													  LPCTSTR userid,
													  LPCTSTR nickname,
													  int time,
													  UINT membercount);


	virtual void CALLBACK NtalkClient_OnAckSendMsg(INTalkClient* pNtClient, 
													 int roomid, 
													 UINT msg_seq, 
													 LPCTSTR userid, 
													 UINT tid,
													 int time);

	virtual void CALLBACK NtalkClient_OnAckSendFile(INTalkClient* pNtClient, int roomid, UINT msg_seq, LPCTSTR userid, UINT tid, int time);

	virtual void CALLBACK NtalkClient_OnInitRoom(INTalkClient* pNTClient, int roomid, NTalkCreateSesionErrorCode eErrorCode);

	virtual void CALLBACK NtalkClient_OnInviteList(INTalkClient* pNtClient, int roomid, NTalkInviteListErrorCode eErrorCode, 
															UINT nTotalMemberCount, UINT nTryCount, UINT nFailCount, std::vector<TCHAR*>& vecUserList); 
	
	virtual void CALLBACK NtalkClient_OnRoomEnd(INTalkClient* pNtClient, int roomid, int type); 

    virtual void CALLBACK NtalkClient_OnSessionEnd(INTalkClient* pNTClient, int roomid, LPCTSTR userid, 
        LPCTSTR nickname, int nOSType);

	virtual void CALLBACK NtalkClient_OnServerNotReady(INTalkClient* pNtClient); 

	virtual void CALLBACK NtalkClient_OnSendMsgFail(INTalkClient* pNtClient, int roomid, UINT msg_seq, UINT tid, int time, 
																	int os_type, std::vector<COMM_USERINFO *>& vecFailUser);
	virtual void CALLBACK NtalkClient_OnMsgResult(INTalkClient* pNtClient, int room_id, UINT msg_seq, UINT tid, int time, 
													int os_type, int result_seq, std::vector<SEND_MSGRESULT *>& vecUserMsgResult);
	virtual void CALLBACK NtalkClient_OnServerSessionEnd(INTalkClient* pNtClient);

	virtual void CALLBACK NtalkClient_OnRecvPong();

	virtual bool OnGTWASActor_ResponseGetNewRoom(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const GT_ROOM_DATA &sRoomInfo);
	virtual bool OnGTWASActor_ResponseGetTalkName(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const std::vector<NT_TALKNAME_DATA> &listTalknameData);
	virtual bool OnGTWASActor_ResponseGetMessages(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const std::vector<NE_MESSAGE_DATA> &listMessage);

	void    DrawSlideBar(HDC hDC);
	void    SetAlpha(int nValue);
	void ResortChatListByName();
	void SetWindowPosition(CWindowWnd* pWnd, CWnd* pParentWnd, CRect rcParent,int ww,int hh); 
	CString _GetChatDlgTitleStr() /*Get current title string */;
	public:
		//CFileDialogEx*   m_fileDlg;

};

class CDialogBuilderCallbackChatEx : public IDialogBuilderCallback
{
public:
	CDialogBuilderCallbackChatEx(CChatDlg *pMainFrame)
	{
		m_pMainFrame = pMainFrame;
	}
	CControlUI* CreateControl(LPCTSTR pstrClass)
	{
		return m_pMainFrame->CreateControl(pstrClass);
	}
	CChatDlg *m_pMainFrame;
};